﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private readonly HashSet<ValidationError> errors = new HashSet<ValidationError>();
        PersonViewModel vm;
        public MainWindow()
        {
            InitializeComponent();
            vm = new PersonViewModel();
            this.DataContext = vm;
            Validation.AddErrorHandler(this, ErrorChangedHandler);
        }
        private void ErrorChangedHandler(object sender, ValidationErrorEventArgs e)
        {
            if (e.Action == ValidationErrorEventAction.Added)
            {
                errors.Add(e.Error);
            }
            else
            {
                errors.Remove(e.Error);
            }

            vm.IsValid = errors.Count == 0;
        }

    }
}
