﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using System.Windows.Input;
using Microsoft.Practices.Composite;
using Microsoft.Practices.Composite.Presentation.Commands;

namespace WpfApplication1
{
    class PersonViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Person> _PersonList;
        public ObservableCollection<Person> PersonList
        {
            get { return _PersonList; }
            set
            {
                _PersonList = value;
                RaisePropertyChanged("PersonList");
            }
        }

        private Person _Person1;
        public Person Person1
        {
            get { return _Person1; }
            set
            {
                _Person1 = value;
                RaisePropertyChanged("Person1");
            }
        }
 
        private bool _IsValid=true;
        public bool IsValid
        {
            get { return _IsValid; }
            set
            {
                _IsValid = value;
                RaisePropertyChanged("IsValid");
                SaveCommand.RaiseCanExecuteChanged();
            }
        }

        private DelegateCommand<object> _SaveCommand;
        public DelegateCommand<object> SaveCommand
        {
            get { return _SaveCommand; }
            set
            {
                _SaveCommand = value;
                RaisePropertyChanged("SaveCommand");
            }

        }

        private void OnSave(object param)
        {
        }

     

        private bool OnSaveCanExecute(object param)
        {
            return IsValid;
        }








        public PersonViewModel()
        {
            _SaveCommand = new DelegateCommand<object>(OnSave, OnSaveCanExecute);
            PersonList = new ObservableCollection<Person>();
            PersonList.Add(new Person("Mr.A", Convert.ToDateTime("12/1/1983"), 26));
            PersonList.Add(new Person("Mr.B", Convert.ToDateTime("12/2/1983"), 126));
            PersonList.Add(new Person("Mr.C", Convert.ToDateTime("12/3/1983"), -1));
            PersonList.Add(new Person("Mr.X", Convert.ToDateTime("12/4/1983"), 26));
            Person1 = new Person();
        }



        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;
        /// <summary>
        /// Raises the <see cref="E:PropertyChanged"/> event.
        /// </summary>
        /// <param name="e">The <see cref="System.ComponentModel.PropertyChangedEventArgs"/> instance containing the event data.</param>
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, e);
            }
        }

        protected void RaisePropertyChanged(string propertyName)
        {

            OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
